Merge remote-tracking branch 'donkult/feature/generalize-gzipindex' into debian/sid
[ntk/apt.git] / test / integration / framework
1 #!/bin/sh -- # no runable script, just for vi
2
3 EXIT_CODE=0
4
5 # we all like colorful messages
6 if [ "$MSGCOLOR" != 'NO' ]; then
7 if [ ! -t 1 ]; then # but check that we output to a terminal
8 export MSGCOLOR='NO'
9 fi
10 fi
11
12
13 if [ "$MSGCOLOR" != 'NO' ]; then
14 CERROR="\033[1;31m" # red
15 CWARNING="\033[1;33m" # yellow
16 CMSG="\033[1;32m" # green
17 CINFO="\033[1;96m" # light blue
18 CDEBUG="\033[1;94m" # blue
19 CNORMAL="\033[0;39m" # default system console color
20 CDONE="\033[1;32m" # green
21 CPASS="\033[1;32m" # green
22 CFAIL="\033[1;31m" # red
23 CCMD="\033[1;35m" # pink
24 fi
25
26 msgdie() { printf "${CERROR}E: $1${CNORMAL}\n" >&2; exit 1; }
27 msgwarn() { printf "${CWARNING}W: $1${CNORMAL}\n" >&2; }
28 msgmsg() { printf "${CMSG}$1${CNORMAL}\n"; }
29 msginfo() { printf "${CINFO}I: $1${CNORMAL}\n"; }
30 msgdebug() { printf "${CDEBUG}D: $1${CNORMAL}\n"; }
31 msgdone() { printf "${CDONE}DONE${CNORMAL}\n"; }
32 msgnwarn() { printf "${CWARNING}W: $1${CNORMAL}" >&2; }
33 msgnmsg() { printf "${CMSG}$1${CNORMAL}"; }
34 msgninfo() { printf "${CINFO}I: $1${CNORMAL}"; }
35 msgndebug() { printf "${CDEBUG}D: $1${CNORMAL}"; }
36 msgtest() {
37 while [ -n "$1" ]; do
38 printf "${CINFO}$1${CCMD} "
39 printf -- "$(echo "$2" | sed -e 's#^apt\([cgfs]\)#apt-\1#')${CINFO} "
40 shift
41 if [ -n "$1" ]; then shift; else break; fi
42 done
43 printf "…${CNORMAL} "
44 }
45 msgpass() { printf "${CPASS}PASS${CNORMAL}\n"; }
46 msgskip() { printf "${CWARNING}SKIP${CNORMAL}\n" >&2; }
47 msgfail() {
48 if [ $# -gt 0 ]; then printf "${CFAIL}FAIL: $*${CNORMAL}\n" >&2;
49 else printf "${CFAIL}FAIL${CNORMAL}\n" >&2; fi
50 EXIT_CODE=$((EXIT_CODE+1));
51 }
52
53 # enable / disable Debugging
54 MSGLEVEL=${MSGLEVEL:-3}
55 if [ $MSGLEVEL -le 0 ]; then
56 msgdie() { true; }
57 fi
58 if [ $MSGLEVEL -le 1 ]; then
59 msgwarn() { true; }
60 msgnwarn() { true; }
61 fi
62 if [ $MSGLEVEL -le 2 ]; then
63 msgmsg() { true; }
64 msgnmsg() { true; }
65 msgtest() { true; }
66 msgpass() { printf " ${CPASS}P${CNORMAL}"; }
67 msgskip() { printf " ${CWARNING}S${CNORMAL}" >&2; }
68 if [ -n "$CFAIL" ]; then
69 msgfail() { printf " ${CFAIL}FAIL${CNORMAL}" >&2; EXIT_CODE=$((EXIT_CODE+1)); }
70 else
71 msgfail() { printf " ###FAILED###" >&2; EXIT_CODE=$((EXIT_CODE+1)); }
72 fi
73 fi
74 if [ $MSGLEVEL -le 3 ]; then
75 msginfo() { true; }
76 msgninfo() { true; }
77 fi
78 if [ $MSGLEVEL -le 4 ]; then
79 msgdebug() { true; }
80 msgndebug() { true; }
81 fi
82 msgdone() {
83 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
84 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
85 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
86 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
87 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
88 true;
89 else
90 printf "${CDONE}DONE${CNORMAL}\n";
91 fi
92 }
93 getaptconfig() {
94 if [ -f ./aptconfig.conf ]; then
95 echo "./aptconfig.conf"
96 elif [ -f ../aptconfig.conf ]; then
97 echo "../aptconfig.conf"
98 fi
99 }
100 runapt() {
101 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
102 local CMD="$1"
103 shift
104 case $CMD in
105 sh|aptitude|*/*) ;;
106 *) CMD="${BUILDDIRECTORY}/$CMD";;
107 esac
108 MALLOC_PERTURB_=21 MALLOC_CHECK_=2 APT_CONFIG="$(getaptconfig)" LD_LIBRARY_PATH=${BUILDDIRECTORY} $CMD "$@"
109 }
110 aptconfig() { runapt apt-config "$@"; }
111 aptcache() { runapt apt-cache "$@"; }
112 aptcdrom() { runapt apt-cdrom "$@"; }
113 aptget() { runapt apt-get "$@"; }
114 aptftparchive() { runapt apt-ftparchive "$@"; }
115 aptkey() { runapt apt-key "$@"; }
116 aptmark() { runapt apt-mark "$@"; }
117 aptsortpkgs() { runapt apt-sortpkgs "$@"; }
118 apt() { runapt apt "$@"; }
119 apthelper() { runapt "${APTHELPERBINDIR}/apt-helper" "$@"; }
120 aptwebserver() { runapt "${APTWEBSERVERBINDIR}/aptwebserver" "$@"; }
121 aptitude() { runapt aptitude "$@"; }
122 aptextracttemplates() { runapt apt-extracttemplates "$@"; }
123 aptinternalsolver() { runapt "${APTINTERNALSOLVER}" "$@"; }
124
125 dpkg() {
126 command dpkg --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log "$@"
127 }
128 dpkgcheckbuilddeps() {
129 command dpkg-checkbuilddeps --admindir=${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg "$@"
130 }
131 gdb() {
132 echo "gdb: run »$*«"
133 CMD="$1"
134 shift
135
136 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${LIBRARYPATH} command gdb ${BUILDDIRECTORY}/$CMD --args ${BUILDDIRECTORY}/$CMD "$@"
137 }
138 gpg() {
139 # see apt-key for the whole trickery. Setup is done in setupenvironment
140 command gpg --ignore-time-conflict --no-options --no-default-keyring \
141 --homedir "${TMPWORKINGDIRECTORY}/gnupghome" \
142 --no-auto-check-trustdb --trust-model always \
143 "$@"
144 }
145
146 exitwithstatus() {
147 # error if we about to overflow, but ...
148 # "255 failures ought to be enough for everybody"
149 if [ $EXIT_CODE -gt 255 ]; then
150 msgdie "Total failure count $EXIT_CODE too big"
151 fi
152 exit $((EXIT_CODE <= 255 ? EXIT_CODE : 255));
153 }
154
155 shellsetedetector() {
156 local exit_status=$?
157 if [ "$exit_status" != '0' ]; then
158 printf >&2 "${CERROR}E: Looks like the testcases ended prematurely with exitcode: ${exit_status}${CNORMAL}\n"
159 if [ "$EXIT_CODE" = '0' ]; then
160 EXIT_CODE="$exit_status"
161 fi
162 fi
163 }
164
165 addtrap() {
166 if [ "$1" = 'prefix' ]; then
167 CURRENTTRAP="$2 $CURRENTTRAP"
168 else
169 CURRENTTRAP="$CURRENTTRAP $1"
170 fi
171 trap "shellsetedetector; $CURRENTTRAP exitwithstatus;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
172 }
173
174 setupenvironment() {
175 TMPWORKINGDIRECTORY=$(mktemp -d)
176 TESTDIRECTORY=$(readlink -f $(dirname $0))
177 msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
178
179 # allow overriding the default BUILDDIR location
180 BUILDDIRECTORY=${APT_INTEGRATION_TESTS_BUILD_DIR:-"${TESTDIRECTORY}/../../build/bin"}
181 LIBRARYPATH=${APT_INTEGRATION_TESTS_LIBRARY_PATH:-"${BUILDDIRECTORY}"}
182 METHODSDIR=${APT_INTEGRATION_TESTS_METHODS_DIR:-"${BUILDDIRECTORY}/methods"}
183 APTHELPERBINDIR=${APT_INTEGRATION_TESTS_LIBEXEC_DIR:-"${BUILDDIRECTORY}"}
184 APTWEBSERVERBINDIR=${APT_INTEGRATION_TESTS_WEBSERVER_BIN_DIR:-"${BUILDDIRECTORY}"}
185 APTINTERNALSOLVER=${APT_INTEGRATION_TESTS_INTERNAL_SOLVER:-"${BUILDDIRECTORY}/apt-internal-solver"}
186 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
187 # -----
188
189 addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY;"
190 cd $TMPWORKINGDIRECTORY
191 mkdir rootdir aptarchive keys
192 cd rootdir
193 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
194 mkdir -p var/cache var/lib/apt var/log tmp
195 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
196 touch var/lib/dpkg/available
197 mkdir -p usr/lib/apt
198 ln -s ${METHODSDIR} usr/lib/apt/methods
199 if [ "$BUILDDIRECTORY" = "$LIBRARYPATH" ]; then
200 mkdir -p usr/lib/apt/solvers
201 ln -s "${BUILDDIRECTORY}/apt-dump-solver" usr/lib/apt/solvers/dump
202 ln -s "${BUILDDIRECTORY}/apt-internal-solver" usr/lib/apt/solvers/apt
203 echo "Dir::Bin::Solvers \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/solvers\";" > etc/apt/apt.conf.d/externalsolver.conf
204 fi
205 # use the autoremove from the BUILDDIRECTORY if its there, otherwise
206 # system
207 if [ -e ${BUILDDIRECTORY}/../../debian/apt.conf.autoremove ]; then
208 ln -s ${BUILDDIRECTORY}/../../debian/apt.conf.autoremove etc/apt/apt.conf.d/01autoremove
209 else
210 ln -s /etc/apt/apt.conf.d/01autoremove etc/apt/apt.conf.d/01autoremove
211 fi
212 cd ..
213 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
214 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
215 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
216 fi
217 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
218 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
219 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive/Sources
220 fi
221 cp $(find $TESTDIRECTORY -name '*.pub' -o -name '*.sec') keys/
222 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
223 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
224 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
225 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
226 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
227 echo "Dir::Bin::Methods \"${METHODSDIR}\";" >> aptconfig.conf
228 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
229 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
230 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
231 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
232 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
233 if ! command dpkg --assert-multi-arch >/dev/null 2>&1; then
234 echo "DPKG::options:: \"--force-architecture\";" >> aptconfig.conf # Added to test multiarch before dpkg is ready for it…
235 fi
236 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
237 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
238 echo "Acquire::https::CaInfo \"${TESTDIR}/apt.pem\";" > rootdir/etc/apt/apt.conf.d/99https
239 echo "Apt::Cmd::Disable-Script-Warning \"1\";" > rootdir/etc/apt/apt.conf.d/apt-binary
240 configcompression '.' 'gz' #'bz2' 'lzma' 'xz'
241
242 # gpg needs a trustdb to function, but it can't be invalid (not even empty)
243 # see also apt-key where this trickery comes from:
244 local TRUSTDBDIR="${TMPWORKINGDIRECTORY}/gnupghome"
245 mkdir "$TRUSTDBDIR"
246 chmod 700 "$TRUSTDBDIR"
247 # We also don't use a secret keyring, of course, but gpg panics and
248 # implodes if there isn't one available - and writeable for imports
249 local SECRETKEYRING="${TRUSTDBDIR}/secring.gpg"
250 touch $SECRETKEYRING
251 # now create the trustdb with an (empty) dummy keyring
252 # newer gpg versions are fine without it, but play it safe for now
253 gpg --quiet --check-trustdb --secret-keyring $SECRETKEYRING --keyring $SECRETKEYRING >/dev/null 2>&1
254
255 # cleanup the environment a bit
256 export PATH="${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
257 export LC_ALL=C.UTF-8
258 unset LANGUAGE APT_CONFIG
259 unset GREP_OPTIONS DEB_BUILD_PROFILES
260
261 msgdone "info"
262 }
263
264 getarchitecture() {
265 if [ "$1" = "native" -o -z "$1" ]; then
266 eval `aptconfig shell ARCH APT::Architecture`
267 if [ -n "$ARCH" ]; then
268 echo $ARCH
269 else
270 dpkg --print-architecture
271 fi
272 else
273 echo $1
274 fi
275 }
276
277 getarchitectures() {
278 echo "$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
279 }
280
281 getarchitecturesfromcommalist() {
282 echo "$1" | sed -e 's#,#\n#g' | sed -e "s/^native\$/$(getarchitecture 'native')/"
283 }
284
285 configarchitecture() {
286 {
287 echo "APT::Architecture \"$(getarchitecture $1)\";"
288 while [ -n "$1" ]; do
289 echo "APT::Architectures:: \"$(getarchitecture $1)\";"
290 shift
291 done
292 } >rootdir/etc/apt/apt.conf.d/01multiarch.conf
293 configdpkg
294 }
295
296 configdpkg() {
297 if [ ! -e rootdir/var/lib/dpkg/status ]; then
298 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
299 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
300 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
301 else
302 echo -n > rootdir/var/lib/dpkg/status
303 fi
304 fi
305 rm -f rootdir/etc/apt/apt.conf.d/00foreigndpkg
306 if command dpkg --assert-multi-arch >/dev/null 2>&1 ; then
307 local ARCHS="$(getarchitectures)"
308 if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
309 DPKGARCH="$(dpkg --print-architecture)"
310 for ARCH in ${ARCHS}; do
311 if [ "${ARCH}" != "${DPKGARCH}" ]; then
312 if ! dpkg --add-architecture ${ARCH} >/dev/null 2>&1; then
313 # old-style used e.g. in Ubuntu-P – and as it seems travis
314 echo "DPKG::options:: \"--foreign-architecture\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
315 echo "DPKG::options:: \"${ARCH}\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
316 fi
317 fi
318 done
319 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
320 # dpkg doesn't really check the version as long as it is fully installed,
321 # but just to be sure we choose one above the required version
322 insertinstalledpackage 'dpkg' "all" '1.16.2+fake'
323 fi
324 fi
325 fi
326 }
327
328 configcompression() {
329 while [ -n "$1" ]; do
330 case "$1" in
331 '.') printf ".\t.\tcat\n";;
332 'gz') printf "gzip\tgz\tgzip\n";;
333 'bz2') printf "bzip2\tbz2\tbzip2\n";;
334 'lzma') printf "lzma\tlzma\txz --format=lzma\n";;
335 'xz') printf "xz\txz\txz\n";;
336 *) printf "$1\t$1\t$1\n";;
337 esac
338 shift
339 done > ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf
340 }
341
342 forcecompressor() {
343 COMPRESSOR="$1"
344 COMPRESSOR_CMD="$1"
345 case $COMPRESSOR in
346 gzip) COMPRESS='gz';;
347 bzip2) COMPRESS='bz2';;
348 lzma) COMPRESS='lzma';;
349 xz) COMPRESS='xz';;
350 *) msgdie "Compressor $COMPRESSOR is unknown to framework, so can't be forced by forcecompressor!";;
351 esac
352 local CONFFILE="${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/00force-compressor"
353 echo "Acquire::CompressionTypes::Order { \"${COMPRESS}\"; };
354 Dir::Bin::uncompressed \"/does/not/exist\";
355 Dir::Bin::gzip \"/does/not/exist\";
356 Dir::Bin::bzip2 \"/does/not/exist\";
357 Dir::Bin::lzma \"/does/not/exist\";
358 Dir::Bin::xz \"/does/not/exist\";" > "$CONFFILE"
359 if [ -e "/bin/${COMPRESSOR}" ]; then
360 echo "Dir::Bin::${COMPRESSOR} \"/bin/${COMPRESSOR}\";" >> "$CONFFILE"
361 elif [ -e "/usr/bin/${COMPRESSOR}" ]; then
362 echo "Dir::Bin::${COMPRESSOR} \"/usr/bin/${COMPRESSOR}\";" >> "$CONFFILE"
363 elif [ "${COMPRESSOR}" = 'lzma' ]; then
364 echo 'Dir::Bin::xz "/usr/bin/xz";' >> "$CONFFILE"
365 COMPRESSOR_CMD='xz --format=lzma'
366 else
367 msgtest 'Test for availability of compressor' "${COMPRESSOR}"
368 msgfail
369 fi
370 }
371
372 setupsimplenativepackage() {
373 local NAME="$1"
374 local ARCH="$2"
375 local VERSION="$3"
376 local RELEASE="${4:-unstable}"
377 local DEPENDENCIES="$5"
378 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
379 If you find such a package installed on your system,
380 something went horribly wrong! They are autogenerated
381 und used only by testcases and surf no other propose…"}"
382
383 local SECTION="${7:-others}"
384 local DISTSECTION
385 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
386 DISTSECTION="main"
387 else
388 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
389 fi
390 local BUILDDIR=incoming/${NAME}-${VERSION}
391 mkdir -p ${BUILDDIR}/debian/source
392 cd ${BUILDDIR}
393 echo "* most suckless software product ever" > FEATURES
394 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
395 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
396
397 * Initial release
398
399 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
400 test -e debian/control || echo "Source: $NAME
401 Section: $SECTION
402 Priority: optional
403 Maintainer: Joe Sixpack <joe@example.org>
404 Build-Depends: debhelper (>= 7)
405 Standards-Version: 3.9.1
406
407 Package: $NAME" > debian/control
408 if [ "$ARCH" = 'all' ]; then
409 echo "Architecture: all" >> debian/control
410 else
411 echo "Architecture: any" >> debian/control
412 fi
413 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
414 echo "Description: $DESCRIPTION" >> debian/control
415
416 test -e debian/compat || echo "7" > debian/compat
417 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
418 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
419 cd - > /dev/null
420 }
421
422 buildsimplenativepackage() {
423 local NAME="$1"
424 local ARCH="$2"
425 local VERSION="$3"
426 local RELEASE="${4:-unstable}"
427 local DEPENDENCIES="$5"
428 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
429 If you find such a package installed on your system,
430 something went horribly wrong! They are autogenerated
431 und used only by testcases and surf no other propose…"}"
432
433 local SECTION="${7:-others}"
434 local PRIORITY="${8:-optional}"
435 local FILE_TREE="$9"
436 local COMPRESS_TYPE="${10:-gzip}"
437 local DISTSECTION
438 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
439 DISTSECTION="main"
440 else
441 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
442 fi
443 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
444
445 msgninfo "Build package ${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}… "
446 mkdir -p $BUILDDIR/debian/source
447 echo "* most suckless software product ever" > ${BUILDDIR}/FEATURES
448 echo "#!/bin/sh
449 echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
450
451 echo "Copyleft by Joe Sixpack $(date +%Y)" > ${BUILDDIR}/debian/copyright
452 echo "$NAME ($VERSION) $RELEASE; urgency=low
453
454 * Initial release
455
456 -- Joe Sixpack <joe@example.org> $(date -R)" > ${BUILDDIR}/debian/changelog
457 echo "Source: $NAME
458 Section: $SECTION
459 Priority: $PRIORITY
460 Maintainer: Joe Sixpack <joe@example.org>
461 Standards-Version: 3.9.3" > ${BUILDDIR}/debian/control
462 local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')"
463 test -z "$BUILDDEPS" || echo "$BUILDDEPS" >> ${BUILDDIR}/debian/control
464 echo "
465 Package: $NAME" >> ${BUILDDIR}/debian/control
466
467 if [ "$ARCH" = 'all' ]; then
468 echo "Architecture: all" >> ${BUILDDIR}/debian/control
469 else
470 echo "Architecture: any" >> ${BUILDDIR}/debian/control
471 fi
472 local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')"
473 test -z "$DEPS" || echo "$DEPS" >> ${BUILDDIR}/debian/control
474 echo "Description: $DESCRIPTION" >> ${BUILDDIR}/debian/control
475
476 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
477 (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | sed -n 's#^dpkg-source: info: building [^ ]\+ in ##p' \
478 | while read SRC; do
479 echo "pool/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
480 # if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then
481 # gpg --yes --secret-keyring ./keys/joesixpack.sec \
482 # --keyring ./keys/joesixpack.pub --default-key 'Joe Sixpack' \
483 # --clearsign -o "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
484 # mv "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
485 # fi
486 done
487
488 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
489 rm -rf ${BUILDDIR}/debian/tmp
490 mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
491 cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
492 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}
493 if [ -n "$FILE_TREE" ]; then
494 cp -ar "$FILE_TREE" ${BUILDDIR}/debian/tmp
495 fi
496
497 (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$arch)
498 (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
499 local LOG="${BUILDDIR}/../${NAME}_${VERSION}_${arch}.dpkg-deb.log"
500 # ensure the right permissions as dpkg-deb ensists
501 chmod 755 ${BUILDDIR}/debian/tmp/DEBIAN
502 if ! dpkg-deb -Z${COMPRESS_TYPE} --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/.. >$LOG 2>&1; then
503 cat $LOG
504 false
505 fi
506 rm $LOG
507 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
508 done
509
510 mkdir -p ${BUILDDIR}/../${NAME}_${VERSION}
511 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}/
512 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}.changelog
513 rm -rf "${BUILDDIR}"
514 msgdone "info"
515 }
516
517 buildpackage() {
518 local BUILDDIR=$1
519 local RELEASE=$2
520 local SECTION=$3
521 local ARCH=$(getarchitecture $4)
522 local PKGNAME="$(echo "$BUILDDIR" | grep -o '[^/]*$')"
523 local BUILDLOG="$(readlink -f "${BUILDDIR}/../${PKGNAME}_${RELEASE}_${SECTION}.dpkg-bp.log")"
524 msgninfo "Build package ${PKGNAME} for ${RELEASE} in ${SECTION}… "
525 cd $BUILDDIR
526 if [ "$ARCH" = "all" ]; then
527 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
528 fi
529 if ! dpkg-buildpackage -uc -us -a$ARCH >$BUILDLOG 2>&1 ; then
530 cat $BUILDLOG
531 false
532 fi
533 local PKGS="$(grep '^dpkg-deb: building package' $BUILDLOG | cut -d'/' -f 2 | sed -e "s#'\.##")"
534 local SRCS="$(grep '^dpkg-source: info: building' $BUILDLOG | grep -o '[a-z0-9._+~-]*$')"
535 cd - > /dev/null
536 for PKG in $PKGS; do
537 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
538 done
539 for SRC in $SRCS; do
540 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
541 done
542 msgdone "info"
543 }
544
545 buildaptarchive() {
546 if [ -d incoming ]; then
547 buildaptarchivefromincoming "$@"
548 else
549 buildaptarchivefromfiles "$@"
550 fi
551 }
552
553 createaptftparchiveconfig() {
554 local COMPRESSORS="$(cut -d' ' -f 1 ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | tr '\n' ' ')"
555 COMPRESSORS="${COMPRESSORS%* }"
556 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
557 if [ -z "$ARCHS" ]; then
558 # the pool is empty, so we will operate on faked packages - let us use the configured archs
559 ARCHS="$(getarchitectures)"
560 fi
561 echo -n 'Dir {
562 ArchiveDir "' >> ftparchive.conf
563 echo -n $(readlink -f .) >> ftparchive.conf
564 echo -n '";
565 CacheDir "' >> ftparchive.conf
566 echo -n $(readlink -f ..) >> ftparchive.conf
567 echo -n '";
568 FileListDir "' >> ftparchive.conf
569 echo -n $(readlink -f pool/) >> ftparchive.conf
570 echo -n '";
571 };
572 Default {
573 Packages::Compress "'"$COMPRESSORS"'";
574 Sources::Compress "'"$COMPRESSORS"'";
575 Contents::Compress "'"$COMPRESSORS"'";
576 Translation::Compress "'"$COMPRESSORS"'";
577 LongDescription "false";
578 };
579 TreeDefault {
580 Directory "pool/";
581 SrcDirectory "pool/";
582 };
583 APT {
584 FTPArchive {
585 Release {
586 Origin "joesixpack";
587 Label "apttestcases";
588 Suite "unstable";
589 Description "repository with dummy packages";
590 Architectures "' >> ftparchive.conf
591 echo -n "$ARCHS" >> ftparchive.conf
592 echo 'source";
593 };
594 };
595 };' >> ftparchive.conf
596 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
597 echo -n 'tree "dists/' >> ftparchive.conf
598 echo -n "$DIST" >> ftparchive.conf
599 echo -n '" {
600 Architectures "' >> ftparchive.conf
601 echo -n "$ARCHS" >> ftparchive.conf
602 echo -n 'source";
603 FileList "' >> ftparchive.conf
604 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
605 echo -n '";
606 SourceFileList "' >> ftparchive.conf
607 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
608 echo -n '";
609 Sections "' >> ftparchive.conf
610 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
611 echo '";
612 };' >> ftparchive.conf
613 done
614 }
615
616 buildaptftparchivedirectorystructure() {
617 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
618 for DIST in $DISTS; do
619 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
620 for SECTION in $SECTIONS; do
621 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
622 for ARCH in $ARCHS; do
623 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
624 done
625 mkdir -p dists/${DIST}/${SECTION}/source
626 mkdir -p dists/${DIST}/${SECTION}/i18n
627 done
628 done
629 }
630
631 insertpackage() {
632 local RELEASE="$1"
633 local NAME="$2"
634 local ARCH="$3"
635 local VERSION="$4"
636 local DEPENDENCIES="$5"
637 local PRIORITY="${6:-optional}"
638 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
639 If you find such a package installed on your system,
640 something went horribly wrong! They are autogenerated
641 und used only by testcases and surf no other propose…"}"
642 local ARCHS=""
643 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
644 if [ "$arch" = 'all' -o "$arch" = 'none' ]; then
645 ARCHS="$(getarchitectures)"
646 else
647 ARCHS="$arch"
648 fi
649 for BUILDARCH in $ARCHS; do
650 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
651 mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source
652 touch aptarchive/dists/${RELEASE}/main/source/Sources
653 local FILE="${PPATH}/Packages"
654 echo "Package: $NAME
655 Priority: $PRIORITY
656 Section: other
657 Installed-Size: 42
658 Maintainer: Joe Sixpack <joe@example.org>" >> $FILE
659 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
660 echo "Version: $VERSION
661 Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE
662 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
663 echo "Description: $DESCRIPTION" >> $FILE
664 echo >> $FILE
665 done
666 done
667 }
668
669 insertsource() {
670 local RELEASE="$1"
671 local NAME="$2"
672 local ARCH="$3"
673 local VERSION="$4"
674 local DEPENDENCIES="$5"
675 local ARCHS=""
676 local SPATH="aptarchive/dists/${RELEASE}/main/source"
677 mkdir -p $SPATH
678 local FILE="${SPATH}/Sources"
679 echo "Package: $NAME
680 Binary: $NAME
681 Version: $VERSION
682 Maintainer: Joe Sixpack <joe@example.org>
683 Architecture: $ARCH" >> $FILE
684 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
685 echo "Files:
686 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.dsc
687 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.tar.gz
688 " >> $FILE
689 }
690
691 insertinstalledpackage() {
692 local NAME="$1"
693 local ARCH="$2"
694 local VERSION="$3"
695 local DEPENDENCIES="$4"
696 local PRIORITY="${5:-optional}"
697 local STATUS="${6:-install ok installed}"
698 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/installed
699 If you find such a package installed on your system,
700 something went horribly wrong! They are autogenerated
701 und used only by testcases and surf no other propose…"}"
702
703 local FILE='rootdir/var/lib/dpkg/status'
704 local INFO='rootdir/var/lib/dpkg/info'
705 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
706 echo "Package: $NAME
707 Status: $STATUS
708 Priority: $PRIORITY
709 Section: other
710 Installed-Size: 42
711 Maintainer: Joe Sixpack <joe@example.org>
712 Version: $VERSION" >> $FILE
713 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
714 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
715 echo "Description: $DESCRIPTION" >> $FILE
716 echo >> $FILE
717 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
718 echo -n > ${INFO}/${NAME}:${arch}.list
719 else
720 echo -n > ${INFO}/${NAME}.list
721 fi
722 done
723 }
724
725
726 buildaptarchivefromincoming() {
727 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
728 cd aptarchive
729 [ -e pool ] || ln -s ../incoming pool
730 [ -e ftparchive.conf ] || createaptftparchiveconfig
731 [ -e dists ] || buildaptftparchivedirectorystructure
732 msgninfo "\tGenerate Packages, Sources and Contents files… "
733 aptftparchive -qq generate ftparchive.conf
734 cd - > /dev/null
735 msgdone "info"
736 generatereleasefiles
737 }
738
739 buildaptarchivefromfiles() {
740 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
741 find aptarchive -name 'Packages' -o -name 'Sources' | while read line; do
742 msgninfo "\t${line} file… "
743 compressfile "$line" "$1"
744 msgdone "info"
745 done
746 generatereleasefiles "$@"
747 }
748
749 compressfile() {
750 cat ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | while read compressor extension command; do
751 if [ "$compressor" = '.' ]; then
752 if [ -n "$2" ]; then
753 touch -d "$2" "$1"
754 fi
755 continue
756 fi
757 cat "$1" | $command > "${1}.${extension}"
758 if [ -n "$2" ]; then
759 touch -d "$2" "${1}.${extension}"
760 fi
761 done
762 }
763
764 # can be overridden by testcases for their pleasure
765 getcodenamefromsuite() {
766 case "$1" in
767 unstable) echo 'sid';;
768 *) echo -n "$1";;
769 esac
770 }
771 getreleaseversionfromsuite() { true; }
772 getlabelfromsuite() { true; }
773
774 generatereleasefiles() {
775 # $1 is the Date header and $2 is the ValidUntil header to be set
776 # both should be given in notation date/touch can understand
777 msgninfo "\tGenerate Release files… "
778 if [ -e aptarchive/dists ]; then
779 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
780 local SUITE="$(echo "$dir" | cut -d'/' -f 4)"
781 local CODENAME="$(getcodenamefromsuite $SUITE)"
782 local VERSION="$(getreleaseversionfromsuite $SUITE)"
783 local LABEL="$(getlabelfromsuite $SUITE)"
784 if [ -n "$VERSION" ]; then
785 VERSION="-o APT::FTPArchive::Release::Version=${VERSION}"
786 fi
787 if [ -n "$LABEL" ]; then
788 LABEL="-o APT::FTPArchive::Release::Label=${LABEL}"
789 fi
790 aptftparchive -qq release $dir \
791 -o APT::FTPArchive::Release::Suite="${SUITE}" \
792 -o APT::FTPArchive::Release::Codename="${CODENAME}" \
793 ${LABEL} \
794 ${VERSION} \
795 | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
796 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
797 sed -i '/^Date: / a\
798 NotAutomatic: yes' $dir/Release
799 fi
800 if [ -n "$1" -a "$1" != "now" ]; then
801 sed -i "s/^Date: .*$/Date: $(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')/" $dir/Release
802 fi
803 if [ -n "$2" ]; then
804 sed -i "/^Date: / a\
805 Valid-Until: $(date -d "$2" '+%a, %d %b %Y %H:%M:%S %Z')" $dir/Release
806 fi
807 done
808 else
809 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
810 fi
811 if [ -n "$1" -a "$1" != "now" ]; then
812 for release in $(find ./aptarchive -name 'Release'); do
813 touch -d "$1" $release
814 done
815 fi
816 msgdone "info"
817 }
818
819 setupdistsaptarchive() {
820 local APTARCHIVE=$(readlink -f ./aptarchive)
821 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
822 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
823 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
824 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
825 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
826 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
827 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
828 msgdone "info"
829 done
830 }
831
832 setupflataptarchive() {
833 local APTARCHIVE=$(readlink -f ./aptarchive)
834 if [ -f ${APTARCHIVE}/Packages ]; then
835 msgninfo "\tadd deb sources.list line… "
836 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
837 msgdone "info"
838 else
839 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
840 fi
841 if [ -f ${APTARCHIVE}/Sources ]; then
842 msgninfo "\tadd deb-src sources.list line… "
843 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
844 msgdone "info"
845 else
846 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
847 fi
848 }
849
850 setupaptarchive() {
851 buildaptarchive
852 if [ -e aptarchive/dists ]; then
853 setupdistsaptarchive
854 else
855 setupflataptarchive
856 fi
857 signreleasefiles
858 if [ "$1" != '--no-update' ]; then
859 msgninfo "\tSync APT's cache with the archive… "
860 aptget update -qq
861 msgdone "info"
862 fi
863 }
864
865 signreleasefiles() {
866 local SIGNER="${1:-Joe Sixpack}"
867 local GPG="gpg --batch --yes"
868 msgninfo "\tSign archive with $SIGNER key… "
869 local REXKEY='keys/rexexpired'
870 local SECEXPIREBAK="${REXKEY}.sec.bak"
871 local PUBEXPIREBAK="${REXKEY}.pub.bak"
872 if [ "${SIGNER}" = 'Rex Expired' ]; then
873 # the key is expired, so gpg doesn't allow to sign with and the --faked-system-time
874 # option doesn't exist anymore (and using faketime would add a new obscure dependency)
875 # therefore we 'temporary' make the key not expired and restore a backup after signing
876 cp ${REXKEY}.sec $SECEXPIREBAK
877 cp ${REXKEY}.pub $PUBEXPIREBAK
878 local SECUNEXPIRED="${REXKEY}.sec.unexpired"
879 local PUBUNEXPIRED="${REXKEY}.pub.unexpired"
880 if [ -f "$SECUNEXPIRED" ] && [ -f "$PUBUNEXPIRED" ]; then
881 cp $SECUNEXPIRED ${REXKEY}.sec
882 cp $PUBUNEXPIRED ${REXKEY}.pub
883 else
884 printf "expire\n1w\nsave\n" | $GPG --keyring ${REXKEY}.pub --secret-keyring ${REXKEY}.sec --command-fd 0 --edit-key "${SIGNER}" >/dev/null 2>&1 || true
885 cp ${REXKEY}.sec $SECUNEXPIRED
886 cp ${REXKEY}.pub $PUBUNEXPIRED
887 fi
888 fi
889 for KEY in $(find keys/ -name '*.sec'); do
890 GPG="$GPG --secret-keyring $KEY"
891 done
892 for KEY in $(find keys/ -name '*.pub'); do
893 GPG="$GPG --keyring $KEY"
894 done
895 for RELEASE in $(find aptarchive/ -name Release); do
896 $GPG --default-key "$SIGNER" --armor --detach-sign --sign --output ${RELEASE}.gpg ${RELEASE}
897 local INRELEASE="$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')"
898 $GPG --default-key "$SIGNER" --clearsign --output $INRELEASE $RELEASE
899 # we might have set a specific date for the Release file, so copy it
900 touch -d "$(stat --format "%y" ${RELEASE})" ${RELEASE}.gpg ${INRELEASE}
901 done
902 if [ -f "$SECEXPIREBAK" ] && [ -f "$PUBEXPIREBAK" ]; then
903 mv -f $SECEXPIREBAK ${REXKEY}.sec
904 mv -f $PUBEXPIREBAK ${REXKEY}.pub
905 fi
906 msgdone "info"
907 }
908
909 webserverconfig() {
910 msgtest "Set webserver config option '${1}' to" "$2"
911 local DOWNLOG='rootdir/tmp/download-testfile.log'
912 local STATUS='rootdir/tmp/webserverconfig.status'
913 rm -f "$STATUS" "$DOWNLOG"
914 if downloadfile "http://localhost:8080/_config/set/${1}/${2}" "$STATUS" > "$DOWNLOG"; then
915 msgpass
916 else
917 cat "$DOWNLOG" "$STATUS"
918 msgfail
919 fi
920 testwebserverlaststatuscode '200'
921 }
922
923 rewritesourceslist() {
924 local APTARCHIVE="file://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive")"
925 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
926 sed -i $LIST -e "s#$APTARCHIVE#${1}#" -e "s#http://localhost:8080/#${1}#" -e "s#http://localhost:4433/#${1}#"
927 done
928 }
929
930 # wait for up to 10s for a pid file to appear to avoid possible race
931 # when a helper is started and dosn't write the PID quick enough
932 waitforpidfile() {
933 local PIDFILE="$1"
934 for i in $(seq 10); do
935 if test -s "$PIDFILE"; then
936 return 0
937 fi
938 sleep 1
939 done
940 msgdie "waiting for $PIDFILE failed"
941 return 1
942 }
943
944 changetowebserver() {
945 if [ "$1" != '--no-rewrite' ]; then
946 rewritesourceslist 'http://localhost:8080/'
947 else
948 shift
949 fi
950 if test -x ${APTWEBSERVERBINDIR}/aptwebserver; then
951 cd aptarchive
952 local LOG="webserver.log"
953 if ! aptwebserver -o aptwebserver::fork=1 "$@" >$LOG 2>&1 ; then
954 cat $LOG
955 false
956 fi
957 waitforpidfile aptwebserver.pid
958 local PID="$(cat aptwebserver.pid)"
959 if [ -z "$PID" ]; then
960 msgdie 'Could not fork aptwebserver successfully'
961 fi
962 addtrap "kill $PID;"
963 cd - > /dev/null
964 else
965 msgdie 'You have to build aptwerbserver or install a webserver'
966 fi
967 }
968
969 changetohttpswebserver() {
970 if ! which stunnel4 >/dev/null; then
971 msgdie 'You need to install stunnel4 for https testcases'
972 fi
973 if [ ! -e "${TMPWORKINGDIRECTORY}/aptarchive/aptwebserver.pid" ]; then
974 changetowebserver --no-rewrite "$@"
975 fi
976 echo "pid = ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid
977 cert = ${TESTDIRECTORY}/apt.pem
978 output = /dev/null
979
980 [https]
981 accept = 4433
982 connect = 8080
983 " > ${TMPWORKINGDIRECTORY}/stunnel.conf
984 stunnel4 "${TMPWORKINGDIRECTORY}/stunnel.conf"
985 waitforpidfile "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid"
986 local PID="$(cat ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid)"
987 if [ -z "$PID" ]; then
988 msgdie 'Could not fork stunnel4 successfully'
989 fi
990 addtrap 'prefix' "kill ${PID};"
991 rewritesourceslist 'https://localhost:4433/'
992 }
993
994 changetocdrom() {
995 mkdir -p rootdir/media/cdrom/.disk
996 local CD="$(readlink -f rootdir/media/cdrom)"
997 echo "acquire::cdrom::mount \"${CD}\";
998 acquire::cdrom::${CD}/::mount \"mv ${CD}-unmounted ${CD}\";
999 acquire::cdrom::${CD}/::umount \"mv ${CD} ${CD}-unmounted\";
1000 acquire::cdrom::autodetect 0;" > rootdir/etc/apt/apt.conf.d/00cdrom
1001 echo -n "$1" > ${CD}/.disk/info
1002 if [ ! -d aptarchive/dists ]; then
1003 msgdie 'Flat file archive cdroms can not be created currently'
1004 return 1
1005 fi
1006 mv aptarchive/dists "$CD"
1007 ln -s "$(readlink -f ./incoming)" $CD/pool
1008 find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list' -delete
1009 # start with an unmounted disk
1010 mv "${CD}" "${CD}-unmounted"
1011 # we don't want the disk to be modifiable
1012 addtrap 'prefix' "chmod -f -R +w $PWD/rootdir/media/cdrom/dists/ $PWD/rootdir/media/cdrom-unmounted/dists/ || true;"
1013 chmod -R -w rootdir/media/cdrom-unmounted/dists
1014 }
1015
1016 downloadfile() {
1017 local PROTO="$(echo "$1" | cut -d':' -f 1 )"
1018 apthelper -o Debug::Acquire::${PROTO}=1 \
1019 download-file "$1" "$2" 2>&1 || true
1020 # only if the file exists the download was successful
1021 if [ -e "$2" ]; then
1022 return 0
1023 else
1024 return 1
1025 fi
1026 }
1027
1028 checkdiff() {
1029 local DIFFTEXT="$(command diff -u "$@" | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
1030 if [ -n "$DIFFTEXT" ]; then
1031 echo >&2
1032 echo >&2 "$DIFFTEXT"
1033 return 1
1034 else
1035 return 0
1036 fi
1037 }
1038
1039 testfileequal() {
1040 local FILE="$1"
1041 shift
1042 msgtest "Test for correctness of file" "$FILE"
1043 if [ -z "$*" ]; then
1044 echo -n "" | checkdiff $FILE - && msgpass || msgfail
1045 else
1046 echo "$*" | checkdiff $FILE - && msgpass || msgfail
1047 fi
1048 }
1049
1050 testempty() {
1051 msgtest "Test for no output of" "$*"
1052 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testempty.comparefile"
1053 if $* >$COMPAREFILE 2>&1 && test ! -s $COMPAREFILE; then
1054 msgpass
1055 else
1056 cat $COMPAREFILE
1057 msgfail
1058 fi
1059 }
1060
1061 testequal() {
1062 local MSG='Test of equality of'
1063 if [ "$1" = '--nomsg' ]; then
1064 MSG=''
1065 shift
1066 fi
1067
1068 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.comparefile"
1069 echo "$1" > $COMPAREFILE
1070 shift
1071
1072 if [ -n "$MSG" ]; then
1073 msgtest "$MSG" "$*"
1074 fi
1075 $* 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
1076 }
1077
1078 testequalor2() {
1079 local COMPAREFILE1="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile1"
1080 local COMPAREFILE2="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile2"
1081 local COMPAREAGAINST="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.compareagainst"
1082 echo "$1" > $COMPAREFILE1
1083 echo "$2" > $COMPAREFILE2
1084 shift 2
1085 msgtest "Test for equality OR of" "$*"
1086 $* >$COMPAREAGAINST 2>&1 || true
1087 if checkdiff $COMPAREFILE1 $COMPAREAGAINST >/dev/null 2>&1 || \
1088 checkdiff $COMPAREFILE2 $COMPAREAGAINST >/dev/null 2>&1
1089 then
1090 msgpass
1091 else
1092 echo -n "\n${CINFO}Diff against OR 1${CNORMAL}"
1093 checkdiff $COMPAREFILE1 $COMPAREAGAINST || true
1094 echo -n "${CINFO}Diff against OR 2${CNORMAL}"
1095 checkdiff $COMPAREFILE2 $COMPAREAGAINST || true
1096 msgfail
1097 fi
1098 }
1099
1100 testshowvirtual() {
1101 local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
1102 local PACKAGE="$1"
1103 shift
1104 while [ -n "$1" ]; do
1105 VIRTUAL="${VIRTUAL}
1106 N: Can't select versions from package '$1' as it is purely virtual"
1107 PACKAGE="${PACKAGE} $1"
1108 shift
1109 done
1110 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
1111 VIRTUAL="${VIRTUAL}
1112 N: No packages found"
1113 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.comparefile"
1114 local ARCH="$(getarchitecture 'native')"
1115 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
1116 aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
1117 }
1118
1119 testnopackage() {
1120 msgtest "Test for non-existent packages" "apt-cache show $*"
1121 local SHOWPKG="$(aptcache show "$@" 2>&1 | grep '^Package: ')"
1122 if [ -n "$SHOWPKG" ]; then
1123 echo >&2
1124 echo >&2 "$SHOWPKG"
1125 msgfail
1126 else
1127 msgpass
1128 fi
1129 }
1130
1131 testdpkginstalled() {
1132 msgtest "Test for correctly installed package(s) with" "dpkg -l $*"
1133 local PKGS="$(dpkg -l "$@" 2>/dev/null | grep '^i' | wc -l)"
1134 if [ "$PKGS" != $# ]; then
1135 echo >&2 $PKGS
1136 dpkg -l "$@" | grep '^[a-z]' >&2
1137 msgfail
1138 else
1139 msgpass
1140 fi
1141 }
1142
1143 testdpkgnotinstalled() {
1144 msgtest "Test for correctly not-installed package(s) with" "dpkg -l $*"
1145 local PKGS="$(dpkg -l "$@" 2> /dev/null | grep '^i' | wc -l)"
1146 if [ "$PKGS" != 0 ]; then
1147 echo
1148 dpkg -l "$@" | grep '^[a-z]' >&2
1149 msgfail
1150 else
1151 msgpass
1152 fi
1153 }
1154
1155 testmarkedauto() {
1156 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedauto.comparefile"
1157 if [ -n "$1" ]; then
1158 msgtest 'Test for correctly marked as auto-installed' "$*"
1159 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
1160 else
1161 msgtest 'Test for correctly marked as auto-installed' 'no package'
1162 echo -n > $COMPAREFILE
1163 fi
1164 aptmark showauto 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
1165 }
1166
1167 testsuccess() {
1168 if [ "$1" = '--nomsg' ]; then
1169 shift
1170 else
1171 msgtest 'Test for successful execution of' "$*"
1172 fi
1173 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output"
1174 if $@ >${OUTPUT} 2>&1; then
1175 msgpass
1176 else
1177 echo >&2
1178 cat >&2 $OUTPUT
1179 msgfail
1180 fi
1181 }
1182
1183 testfailure() {
1184 if [ "$1" = '--nomsg' ]; then
1185 shift
1186 else
1187 msgtest 'Test for failure in execution of' "$*"
1188 fi
1189 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output"
1190 if $@ >${OUTPUT} 2>&1; then
1191 echo >&2
1192 cat >&2 $OUTPUT
1193 msgfail
1194 else
1195 msgpass
1196 fi
1197 }
1198
1199 testwebserverlaststatuscode() {
1200 local DOWNLOG='rootdir/tmp/webserverstatus-testfile.log'
1201 local STATUS='rootdir/tmp/webserverstatus-statusfile.log'
1202 rm -f "$DOWNLOG" "$STATUS"
1203 msgtest 'Test last status code from the webserver was' "$1"
1204 downloadfile "http://localhost:8080/_config/find/aptwebserver::last-status-code" "$STATUS" > "$DOWNLOG"
1205 if [ "$(cat "$STATUS")" = "$1" ]; then
1206 msgpass
1207 else
1208 echo >&2
1209 if [ -n "$2" ]; then
1210 shift
1211 echo >&2 '#### Additionally provided output files contain:'
1212 cat >&2 "$@"
1213 fi
1214 echo >&2 '#### Download log of the status code:'
1215 cat >&2 "$DOWNLOG"
1216 msgfail "Status was $(cat "$STATUS")"
1217 fi
1218 }
1219
1220 pause() {
1221 echo "STOPPED execution. Press enter to continue"
1222 local IGNORE
1223 read IGNORE
1224 }